#! /bin/bash

echo Usage:
echo ./generate-hypotheses.sh OWL-FILE SUBCLASS_IRI SUPER_CLASS_IRI TIME-LIMIT=10 [simplify-conjunctions] [remove-redundant-axioms] [semantically-minimal]
echo
echo where OWL-FILE points to an ontology to be used as background knowledge
echo and SUBCLASS_IRI and SUPERCLASS_IRI determine the observation, and the
echo optional argument TIME_LIMIT sets the time limit to the prime implicate
echo generation \(default is 10 seconds\).
echo The list of hypotheses is then printed to the standard output.
# echo If successful, a sequence of OWL files will be created, each containing
# echo a connection minimal hypothesis.
echo


timelimit=10 

#if [ $# >= 4 ]; then
    timelimit=$4
#fi

echo Using time limit of $timelimit

echo generating clauses...

java -cp capi-java-component-0.2-SNAPSHOT-jar-with-dependencies.jar de.tu_dresden.lat.capi.cmd.TranslateAbductionProblem $1 $2 $3 problem.spass

bound=$(( 2 + `cat skolem.bound` ))

echo running SPASS....

./SPASS -SOS -Sorts=0 -Auto=0 -RFSub -RBSub -ISRe -ISFc -FPModel -BoundVars=1 -CNFStrSkolem=0 -CNFOptSkolem=0 -TimeLimit=$timelimit -PGiven=0 -PProblem=0 -BoundMode=2 -BoundStart=$bound -BoundLoops=1 -WDRatio=1 problem.spass

echo building hypotheses...

ontology=$1

shift 4

java -cp capi-java-component-0.2-SNAPSHOT-jar-with-dependencies.jar de.tu_dresden.lat.capi.implicateMatching.ParseAndMatch problem.spass.clauses $ontology $@

