package de.tu_dresden.lat.capi.implicateMatching;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Collectors;

public class Solution {
    private final Set<Subsumption> subsumptions = new HashSet<>();

    public void addSubsumption(Subsumption subsumption){
        this.subsumptions.add(subsumption);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Solution solution = (Solution) o;
        return subsumptions.equals(solution.subsumptions);
    }

    @Override
    public int hashCode() {
        return Objects.hash(subsumptions);
    }

    @Override
    public String toString(){
        return subsumptions.stream()
                .map(c -> c.toString())
                .collect(Collectors.joining("\n"));
    }

    public int size() {
        return subsumptions.size();
    }

    public Set<Subsumption> subsumptions() {
        return subsumptions;
    }
}
